# CellTracking alignment module
# This module is a standalone command line module
# By MW Aug. 2012 GPLv3+

print "USAGE : python CT_alignment.py ./alignment_instruction_file"
print "The alignement folder contains a example.js file showing how the alignemnent\n\
instruction file should be stuctured.\n\n"

basefolder = './exports/alignment/'

import sys, os, json, pickle, shutil

# ===== Functions
def align(nonaligned, phaseframes) :
	frames_before = []
	frames_after = []
	for i in range(len(phaseframes)) :
		frames_before.append(phaseframes[i][0])
		frames_after.append(len(nonaligned[i])-phaseframes[i][0]-1)
		print (frames_before[i], frames_after[i])
		
	if j['_frames_before_alignment'] == -1 :
		f_before = min(frames_before)
	else :
		f_before = j['_frames_before_alignment']
	if j['_frames_after_alignment'] == -1 :
		f_after = min(frames_after)
	else :
		f_after = j['_frames_after_alignment']
	print '--- Aligning'
	print (f_before, f_after)

	na = j['_na_value']
	cropped = []
	#for i in cropped :
	#	print len(cropped)
	for i in range(len(phaseframes)) :
		index = f_after - frames_after[i]
		#print index
		if index >= 0 :
			navector = [na]*index
			cropped.append(nonaligned[i]+navector)
		else :
			cropped.append(nonaligned[i][:index])
	nonaligned = cropped
	aligned = []
	for i in range(len(phaseframes)) :
		index = frames_before[i] - f_before
		if index >= 0 :
			aligned.append(nonaligned[i][index:])
		else :
			navector = [na]*(-1*index)
			aligned.append(navector+nonaligned[i])
	return (aligned,f_before, f_after)


# ====== Main program
try :
	datafile = sys.argv[1]
except :
	print "An alignment instruction file must be specified"
if not os.path.isfile(datafile) :
	print "File not found"
	sys.exit(1)


# ====== Opening datafile
print "-- Opening alignment instructions file"
f = open(datafile, 'r').read()
try :
	j = json.loads(f)
	ret = True
	miss_key = []
	for i in ['_path', '_output_folder', "_normalization_marker", '_alignment_marker', "_frames_before_alignment", "_time_lapse", "_frames_after_alignment", "_na_value", '_get_timing'] :
		if not j.has_key(i) :
			ret = False
			miss_key.append(i)
except Exception, e :
	print "The alignment file should be a valid JSON file \n" + 'Error :' + str(e)
	sys.exit(1)
if not ret :
	print "missing fields in the alignment file : " + str(miss_key)
	sys.exit(1)

# Checking files
print "-- Checking input files"
ok = True
l = []
for p in j['_path'] :
	if not os.path.isfile(p) :
		ok = False
		l.append(p)
if not ok :
	print "Invalid path :"
	for i in l :
		print i
	sys.exit(1)

# ====== Creting list of loaded files
datafiles = []
for p in j['_path'] :
	f = open(p, 'r')
	datafiles.append(f.read())
	f.close()

savefiles = [None]*len(datafiles)
cellindexes = [None]*len(datafiles)
for i in range(len(datafiles)) :
	f = datafiles[i]
	for l in f.split('\n') :
		(ok1, ok2) = (False, False)
		if l[0:11] == 'Save file :' :
			savefiles[i] = l[11:].strip()
			ok1 = True
		if l[0:12] == 'Cell index :' :
			cellindexes[i] = l[12:].strip()
			ok2 = True
		if ok1 and ok2 :
			break	
			
		
if None in cellindexes :
	print "The following files have no valid cell index associated or the save file line cannot\
be found"
	print "A valid cell index line begins with 'Cell index :' (case and spaces ARE important)"
	print "Missing cell indexes :"
	for i in range(len(cellindexes)) :
		if cellindexes[i] == None :
			print j['_path'][i]
	sys.exit(1)
if None in savefiles :
	print "The following files have no valid save file associated or the save file line cannot\
be found"
	print "A valid save file line begins with 'Save file :' (case and spaces ARE important)"
	print "Missing save files :"
	for i in range(len(savefiles)) :
		if savefiles[i] == None :
			print j['_path'][i]
	sys.exit(1)
ret = True
l = []
for p in savefiles :
	if not os.path.isfile(p) :
		l.append(p)
		ret = False
if not ret :
	print "The following files cannot be found, please check locations :"
	for p in l :
		print p
	sys.exit(1)
ret = True
l = []
for i in range(len(j['_path'])) :
	try :
		cellindexes[i] = int(cellindexes[i].strip())
	except :
		ret = False
		l.append(cellindexes[i], j['_path'][i])
if not ret :
	print "The following cell indexes are invalid, please correct them :"
	for p in l :
		print "cell index : " + str(p[0]) + ', in file : ' + p[1]
	sys.exit(1)
	
# ====== Extracting alignment data
print "-- Getting alignment data"
phaseindexes = [None]*len(savefiles)
normindexes = [None]*len(savefiles)
phaseframes = [None]*len(savefiles)
timings = [None]*len(savefiles)
for i in range(len(savefiles)) :
	c = cellindexes[i]
	p = savefiles[i]
	f = open(p, 'rb')
	data = pickle.load(f)
	f.close()
	list_cells = data['cells']['value']['cells']['value']
	if len(list_cells) < c :
		print "There are too few cells registered in the .ct file... Can not continue"
		sys.exit(1)
	cell = list_cells[c]
	#if cell['index']['value'] != c :
	if cell['label']['value'] != c :
		print "Registered index is not corresponding"
		sys.exit(1)
	cell = cell['cell_data']['value']
	phases = cell['phases']['value']['phases']['value']		# A list of phases
	
	ret = False
	l = []
	
	for k in range(len(phases)) :
		phase = phases[k]['phase_data']['value']
		if phase['s_name']['value'] == j['_alignment_marker'] :
			ret = True
			phaseframes[i] = phase['phase_interval']['value']
			phaseindexes[i] = k
		else :
			l.append(phase['s_name']['value'])
		if phase['s_name']['value'] == j['_normalization_marker'] :
			normindexes[i] = phase['phase_interval']['value']
			#print phase['phase_interval']['value']
	
	lt = []
	for marker in j['_get_timing'] :
		for k in range(len(phases)) :
			phase = phases[k]['phase_data']['value']
			if phase['s_name']['value'] == marker :
				lt.append(phase['phase_interval']['value'])
	if len(j['_get_timing']) == len(lt) :
		timings[i] = lt
	else :
		print "Missing keys in the .ct file compared to the _get_timings field"
				
	if not ret :
		print "The alignment marker '" + j['_alignment_marker'] + "' has not been found in the .ct file,"
		print "available alignment markers are :"
		for i in l :
			print i
		sys.exit(1)
if None in normindexes :
	print "Normalization index not found"
	sys.exit(1)
if None in phaseindexes :
	print "Some alignment markers are not found, exiting"
	sys.exit(1)
if None in timings :
	print "Some alignment markers in _get_timings are not found, exiting"
	sys.exit(1)

# ====== Checking phase frames
for i in phaseframes :
	try :
		list(i)
	except :
		print "'phase_interval' is not a list, phase interval="
		print i
		sys.exit(1)
	try :
		for k in i :
			int(k)
	except :
		print "'phase_interval' elements are not integers, phase_interval="
		print i


# ====== Aligning frames
print "-- Computing alignment"

print "Aligning frames : " + str(phaseframes)
print '--- Loading frames'
nonaligned = []		# The nonaligned values
na_count = []
for p in j['_path'] :
	values = []
	f = open(p, 'r')
	lines = f.readlines()
	frame = 0
	na_nb = 0
	na_before = True
	for l in lines :
		l_l = l.split(',')
		try :
			#print float(l_l[1].split('\n')[0].strip())
			if l_l[1].strip() == 'na' and na_before :
				frame += 1
				na_nb += 1
			if int(l_l[0].strip()) == frame :
				# Remember the index of the first frame
				na_before = False
				values.append(float(l_l[1].split('\n')[0].strip()))
				frame+=1
		except :
			pass
	nonaligned.append(values)
	na_count.append(na_nb)
	print str(len(values)) + ' frames detected for movie ' + p

normvalues = [None]*len(nonaligned)
#print [len(normvalues),len(normindexes)]	# DEBUG
for i in range(len(nonaligned)) :
	#print [len(nonaligned[i]), normindexes[i][0], na_count[i]]
	normvalues[i] = nonaligned[i][normindexes[i][0]-na_count[i]]
#print normvalues
if None in normvalues :
	print "Error"
	sys.exit(1)

corrected_indices = []
for i in range(len(phaseframes)) :
	#print phaseframes[i]
	corrected_indices.append([phaseframes[i][0]-na_count[i]])
(aligned,f_before, f_after) = align(nonaligned, corrected_indices)
#aligned_norm = align(nonaligned_norm, phaseframes)
aligned_norm = aligned

nn = []
for w in range(len(aligned)) :
	i=aligned[w]
	nnn = []
	m = min(i)
	normvalues[w] -= m			# Correcting the normalization factor
	for k in i :
		if k != j['_na_value'] :
			nnn.append(k-m)
		else :
			nnn.append(j['_na_value'])
	nn.append(nnn)
print 
nnn = []

for i in range(len(nonaligned)) :
	norm = []
	data = nn[i]
	w=0
	####norm_value = data[f_before]#data[phaseframes[i][0]]
	norm_value = normvalues[i]
	for k in data: 
		if k != j['_na_value'] :
			norm.append(float(k)/norm_value)
		else :
			norm.append(k)
	nnn.append(norm)
aligned_norm = nnn


# ====== Saving
print '-- Saving'
folder = basefolder + j['_output_folder'] + '/'
print 'Save folder is : ' + folder
if os.path.isdir(folder) :
	r = raw_input('The output folder already exists, do you want to overwrite it? (y/n) [n] ')
	if r in ['y', 'Y', 'yes', 'YES', 'Yes'] :
		shutil.rmtree(folder)
	else :
		print 'Exiting'
		sys.exit(1)
		
os.mkdir(folder)
shutil.copy2(datafile, folder + os.path.basename(datafile))

f_norm = open(folder + 'normalized.txt', 'w')
f_unnorm = open(folder + 'raw_data.txt', 'w')
f2_norm = open(folder + '_normalized.txt', 'w')
f2_unnorm = open(folder + '_raw_data.txt', 'w')

labels2 = 'time (min), '
labels = 'Index, Cell index, File path\n'
for i in range(len(j['_path'])) :
	labels += str(i) + ', ' + str(cellindexes[i]) + ', ' + j['_path'][i] + '\n'
	labels2 += 'index ' + str(i) + ', '
labels2 = labels2[:-2] + '\n'
labels += '\n\n'
#labels += labels2
f_norm.write(labels+labels2)
f_unnorm.write(labels+labels2)
f2_norm.write(labels2)
f2_unnorm.write(labels2)

# Creating output string
out_norm = ''
out_unnorm = ''
timeframes = range(-1*j['_time_lapse']*(f_before), j['_time_lapse']*(f_after+2), j['_time_lapse'])
print len(aligned_norm[0]), len(aligned[0])
for i in range(len(aligned[0])) :
	out_norm +=(str(timeframes[i]) + ', ')
	out_unnorm +=(str(timeframes[i]) + ', ')
	for k in range(len(aligned)) :
		#print len( aligned[k]), aligned[k]
		#print '--------------'
		out_norm += str(aligned_norm[k][i]) + ', '
		out_unnorm += str(aligned[k][i]) + ', '
	out_norm = out_norm[:-2]
	out_unnorm = out_unnorm[:-2]
	#print out_unnorm
	f_norm.write(out_norm + '\n')
	f_unnorm.write(out_unnorm + '\n')
	f2_norm.write(out_norm + '\n')
	f2_unnorm.write(out_unnorm + '\n')
	out_norm = ''
	out_unnorm = ''
f_norm.close()
f_unnorm.close()
f2_norm.close()
f2_unnorm.close()

out_timings = ''
out_timings += labels
out_timings += 'index, '
for i in j['_get_timing'] :
	out_timings += i + ', '
out_timings = out_timings[:-2]
out_timings += '\n'
for i in range(len(timings)) :
	line = ''
	line += str(i) + ', '
	for k in timings[i] :
		line += str(k[0]) + ', '
	#line = line[:-2]
	line += '\n'
	out_timings += line
f_timings = open(folder + 'timings.txt', 'w')
f_timings.write(out_timings)
f_timings.close()
	
print '--- Everything saved! Enjoy!'
			
	
