class Feature :
	def __init__(self, movie) :
		self.name = "Phases"
		self.label = "Label phases"
		self.movie = movie
		self.cell = None	# the selected cell (instance)
		self.visible = False
		self.auto_toggle = False
	def get_label(self) :
		return self.label
	def click(self, cell, pt) :
		#self.cb_cell.set_active(cell.get_index())
		self.cb_cell.set_active(cell.get_label())
	def get_frame(self, gtk) :
		self.gtk = gtk
		print "Happily setting frame for " + self.name
		frame = gtk.Frame(self.name)
		main_box = gtk.VBox()
		main_box.show()
		frame.add(main_box)
		
		# Top line (Cell selected, excluded)
		top_box = gtk.HBox()
		top_box.show()
		l_selected = gtk.Label('Selected cell : ')
		l_selected.show()
		top_box.pack_start(l_selected, False, True)
		self.cb_cell = gtk.combo_box_new_text()
		self.cb_cell.show()
		cell_l = self.movie.cells.get_cells_list()
		for i in range(len(cell_l)) :
			self.cb_cell.append_text(str(i))
		self.cb_cell.connect('changed', self._cb_cell_changed)
		top_box.pack_start(self.cb_cell)
		self.b_excluded = gtk.CheckButton('excluded')
		self.b_excluded.show()
		self.b_excluded.set_sensitive(False)
		self.b_excluded.connect("toggled", self._cb_cell_exclude, True)
		top_box.pack_start(self.b_excluded, False, True)
		main_box.pack_start(top_box, False, True)
		sep = gtk.HSeparator()
		sep.show()
		main_box.pack_start(sep)
		
		# Timeline
		l = gtk.Label('Here goes the timeline')
		l.show()
		main_box.pack_start(l)
		
		# Frames scrollable
		scroll = gtk.ScrolledWindow()
		scroll.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
		scroll.show()
		self.features_box = gtk.VBox()
		self.features_box.show()
		scroll.add_with_viewport(self.features_box)
		main_box.pack_start(scroll)
		
		# Bottom box
		sep2 = gtk.HSeparator()
		sep2.show()
		main_box.pack_start(sep2)
		bottom_box = gtk.HBox()
		bottom_box.show()
		b_new_phase = self._bouton(gtk, 'Create new phase', self._new_phase, {})
		bottom_box.pack_start(b_new_phase)
		b_check = self._bouton(gtk, 'Check coherence', self._check, {})
		bottom_box.pack_start(b_check)
		main_box.pack_start(bottom_box, False, True)
		frame.show()
		self.visible = True
		return frame
	def _check(self, w, data=None) :
		print 'checking NI'
	def _new_phase(self, w, data=None) :
		print 'new NI'
	def _cb_cell_changed(self, w, data=None) :
		print w.get_active()
		i = w.get_active()							# Print active
		self.cell = self.movie.cells.get_cells_list()[i]	# Get the instance
		self.b_excluded.set_sensitive(True)		# Activating the button
		self.b_excluded.set_active(not self.cell.is_selected())
		phases = self.cell.phases.get_phases_list()
		for ph in self.features_box.get_children() :
			self.features_box.remove(ph)# Delete old panel
		#self.features_box.foreach()
		for ph in phases :		# Iterate over defined phases
			frame = self.gtk.Frame(ph[1].get_name())# Create frame
			frame.show()
			in_box = ph[1].get_panel(self.gtk)
			in_box.show()
			frame.add(in_box)# Fill frame with a phases function
			self.features_box.pack_start(frame)# Attach frame

	def _cb_cell_exclude(self, w, data=None) :
		#print w.get_active()
		if self.auto_toggle :
			w.set_active(not self.cell.is_selected()) 
		else :
			w.set_active(w.get_active())
			#self.cell.change_select(state=not w.get_active())
			self.cell.gui.change_select(state=not w.get_active())
		self.features_box.set_sensitive(not w.get_active())
		self.auto_toggle = False

	def update(self) :
		if self.visible :
			if self.b_excluded.get_sensitive() and self.b_excluded.get_active() == self.cell.is_selected(): # if the selection and the exclude flag are equals <=> one is select and not the other
				#self._cb_cell_exclude(self.b_excluded)
				self.auto_toggle = True
				self.b_excluded.set_active(not self.cell.is_selected())
		return True
	def _bouton(self, gtk, label, function, dico) :
		"""Function that adds a button to the parent"""
		bouton = gtk.Button(label)			# Creation d'un nouveau bouton.
		bouton.connect("clicked", function, dico)	 # On connecte le signal "clicked" du bouton a la fonction de rappel
		bouton.show()# This packs the button into the window (a GTK container).
		return bouton
